# Begin conversion of database
Dismount-NAVTenant -ServerInstance $newBcServerInstance -Tenant $TenantId -Force
Stop-NAVServerInstance -ServerInstance $newBcServerInstance
Invoke-NAVApplicationDatabaseConversion -DatabaseServer $DatabaseServer -DatabaseName $applicationDatabase -Force
# Result
# PS C:\Users\m.melsatgac.nl\Documents\PowerShell\Scripts\Upgrade Major> Invoke-NAVApplicationDatabaseConversion -DatabaseServer $DatabaseServer -DatabaseName $applicationDatabase -Force
# Cloning metadata for app System by Microsoft (26.0.32469.0) with emit version 26025
# Inplace publishing skipped. Emit version 26025 is current.
# 
# DatabaseServer      : localhost
# DatabaseName        : PRODAPP
# DatabaseCredentials : 
# DatabaseLocation    : 
# Collation           : 
# End conversion of database

# Begin ensure the database name is correctly set
Set-NAVServerConfiguration -ServerInstance $NewBcServerInstance -KeyName DatabaseName -KeyValue $applicationDatabase
Set-NavServerConfiguration -ServerInstance $newBcServerInstance -KeyName Multitenant -KeyValue true
Set-NavServerConfiguration -ServerInstance $NewBcServerInstance -KeyName "EnableTaskScheduler" -KeyValue false
Restart-NAVServerInstance -ServerInstance $NewBcServerInstance
# End ensure the database name is correctly set

# Begin tenant initialization
Dismount-NAVTenant -ServerInstance $newBcServerInstance -Tenant $tenantId -Force
Mount-NAVTenant –ServerInstance $NewBcServerInstance -Id bc  –DatabaseServer localhost -DatabaseName $tenantDatabase -OverwriteTenantIdInDatabase  `
-AlternateId $alternateId -DefaultCompany $defaultCompany -DefaultTimeZone $defaultTimeZone -EnvironmentType $environmentType -DisplayName $displayName -AllowAppDatabaseWrite -Force
Get-NavTenant -ServerInstance $NewBcServerInstance -Tenant $TenantId
Sync-NAVTenant -ServerInstance $NewBcServerInstance -Mode Sync -Tenant $TenantId -Force
# End tenant initialization

# Begin publishing standard extensions
Publish-NAVApp -ServerInstance $NewBcServerInstance -Path $SystemAppPath
Publish-NAVApp -ServerInstance $NewBcServerInstance -Path $BusFoundAppPath
Publish-NAVApp -ServerInstance $NewBcServerInstance -Path $BaseAppPath
Publish-NAVApp -ServerInstance $NewBcServerInstance -Path $ApplicationAppPath
# End publishing standard extensions

# Begin synchronization of standard extensions
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "System Application" -Version $NewBCVersion -Tenant $tenantId
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Business Foundation" -Version $NewBCVersion -Tenant $tenantId
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Base Application" -Version $NewBCVersion -Tenant $tenantId 
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Application" -Version $NewBCVersion -Tenant $tenantId
# End synchronization of standard extensions

# Begin data upgrade of standard extensions
Uninstall-NavApp -ServerInstance $newBcServerInstance -Name "System Application" -Version $oldBCVersion -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name 'System Application'  -Version $NewBcVersion
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name 'Business Foundation'  -Version $NewBcVersion
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name 'Base Application'  -Version $NewBcVersion
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name 'Application'  -Version $NewBcVersion
# End data upgrade of standard extensions

# Begin publishing extension
Publish-NavApp -serverInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\testframework\TestRunner\Microsoft_Test Runner.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Test Runner" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Test Runner" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ContosoCoffeeDemoDataset\Source\Microsoft_Contoso Coffee Demo Dataset.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Contoso Coffee Demo Dataset" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Contoso Coffee Demo Dataset" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Email - Outlook REST API\Source\Microsoft_Email - Outlook REST API.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Email - Outlook REST API" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Email - Outlook REST API" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Email - SMTP API\Source\Microsoft_Email - SMTP API.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Email - SMTP API" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Email - SMTP API" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\StatisticalAccounts\Source\Microsoft_Statistical Accounts.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Statistical Accounts" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Statistical Accounts" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Sustainability\Source\Microsoft_Sustainability.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Sustainability" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Sustainability" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ESGStatisticalAccountsDemoTool\Source\Microsoft_ESG Statistical Accounts Demo Tool.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "ESG Statistical Accounts Demo Tool" -Version $NewBCVersion -Tenant $tenantId
# Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "ESG Statistical Accounts Demo Tool"  -Version $NewBcVersion
Install-NAVApp -ServerInstance $newBcServerInstance -Name "ESG Statistical Accounts Demo Tool" -Version $newBCVersion -Force

# Begin publishing extensions
Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EDocument Core\Source\Microsoft_E-Document Core.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "E-Document Core" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "E-Document Core" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EDocumentConnectors\Pagero\Source\Microsoft_E-Document Connector - Pagero.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "E-Document Connector - Pagero" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "E-Document Connector - Pagero" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\APIV2\Source\Microsoft__Exclude_APIV2_.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_APIV2_" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_APIV2_" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Intrastat\Source\Microsoft_Intrastat Core.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Intrastat Core" -Version $NewBCVersion -Tenant $tenantId
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Intrastat Core" -Version $NewBcVersion

Get-NavAppInfo -ServerInstance $newBcServerInstance -Name "Subscription & Recurring Billing"
Unpublish-NavApp -ServerInstance $newBcServerInstance -Name "Subscription & Recurring Billing"

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\SubscriptionBilling\Source\Microsoft_Subscription Billing.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Subscription Billing" -Version $NewBCVersion -Tenant $tenantId -Mode ForceSync -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Subscription Billing" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Shopify\app\Microsoft_Shopify Connector.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Shopify Connector" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Shopify Connector" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ReviewGLEntries\Source\Microsoft_Review General Ledger Entries.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Review General Ledger Entries" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Review General Ledger Entries" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\AMCBanking365Fundamentals\Source\Microsoft_AMC Banking 365 Fundamentals.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "AMC Banking 365 Fundamentals" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "AMC Banking 365 Fundamentals" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\APIReportsFinance\Source\Microsoft_API Reports - Finance.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "API Reports - Finance" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "API Reports - Finance" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\APIV1\Source\Microsoft__Exclude_APIV1_.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_APIV1_" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_APIV1_" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\BankAccRecWithAI\Source\Microsoft_Bank Account Reconciliation With AI.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Bank Account Reconciliation With AI" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Bank Account Reconciliation With AI" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\BankDeposits\Source\Microsoft__Exclude_Bank Deposits.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_Bank Deposits" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_Bank Deposits" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ClientAddIns\Source\Microsoft__Exclude_ClientAddIns_.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_ClientAddIns_" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_ClientAddIns_" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\CreateProductInformationWithCopilot\Source\Microsoft_Create Product Information With Copilot.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Create Product Information With Copilot" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Create Product Information With Copilot" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\DataArchive\app\Microsoft_Data Archive.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Data Archive" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Data Archive" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\DataCorrectionFA\Source\Microsoft_Troubleshoot FA Ledger Entries.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Troubleshoot FA Ledger Entries" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Troubleshoot FA Ledger Entries" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\DataSearch\app\Microsoft_Data Search.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Data Search" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Data Search" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Email - SMTP Connector\Source\Microsoft_Email - SMTP Connector.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Email - SMTP Connector" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Email - SMTP Connector" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\CompanyHub\Source\Microsoft_Company Hub.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Company Hub" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Company Hub" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EnforcedDigitalVouchers\Source\Microsoft_Enforced Digital Vouchers.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Enforced Digital Vouchers" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Enforced Digital Vouchers" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EssentialBusinessHeadlines\Source\Microsoft_Essential Business Headlines.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Essential Business Headlines" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Essential Business Headlines" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EU3PartyTradePurchase\Source\Microsoft_EU 3-Party Trade Purchase.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "EU 3-Party Trade Purchase" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "EU 3-Party Trade Purchase" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ExcelReports\Source\Microsoft_Dynamics BC Excel Reports.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Dynamics BC Excel Reports" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Dynamics BC Excel Reports" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\External File Storage - Azure Blob Service Connector\Source\Microsoft_External File Storage - Azure Blob Service Connector.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "External File Storage - Azure Blob Service Connector" -Version $NewBCVersion -Tenant $tenantId -Force
# Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "External File Storage - Azure Blob Service Connector" -Version $NewBcVersion
Install-NavApp -ServerInstance $newBcServerInstance -Name "External File Storage - Azure Blob Service Connector" -Version $newBCVersion 

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\External File Storage - Azure File Service Connector\Source\Microsoft_External File Storage - Azure File Service Connector.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "External File Storage - Azure File Service Connector" -Version $NewBCVersion -Tenant $tenantId -Force
# Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "External File Storage - Azure File Service Connector" -Version $NewBcVersion
Install-NavApp -ServerInstance $newBcServerInstance -Name "External File Storage - Azure File Service Connector" -Version $newBCVersion 

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\External File Storage - SharePoint Connector\Source\Microsoft_External File Storage - SharePoint Connector.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "External File Storage - SharePoint Connector" -Version $NewBCVersion -Tenant $tenantId -Force
# Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "External File Storage - SharePoint Connector" -Version $NewBcVersion
Install-NavApp -ServerInstance $newBcServerInstance -Name "External File Storage - SharePoint Connector" -Version $newBCVersion 

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ExternalEvents\Source\Microsoft__Exclude_Business_Events_.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_Business_Events_" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_Business_Events_" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\LatePaymentPredictor\Source\Microsoft_Late Payment Prediction.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Late Payment Prediction" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Late Payment Prediction" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\MasterDataManagement\Source\Microsoft__Exclude_Master_Data_Management.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_Master_Data_Management" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_Master_Data_Management" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\MicrosoftUniversalPrint\Source\Microsoft_Universal Print Integration.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Universal Print Integration" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Universal Print Integration" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\NLDigitalTaxDeclaration\Source\Microsoft_Digital Tax Declaration for the Netherlands.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Digital Tax Declaration for the Netherlands" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Digital Tax Declaration for the Netherlands" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Onprem Permissions\Source\Microsoft_OnPrem Permissions.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "OnPrem Permissions" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "OnPrem Permissions" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\PaymentPractices\Source\Microsoft_Payment Practices.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Payment Practices" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Payment Practices" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\PayPalPaymentsStandard\Source\Microsoft_Payment Links to PayPal.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Payment Links to PayPal" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Payment Links to PayPal" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\PlanConfiguration\Source\Microsoft__Exclude_PlanConfiguration_.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_PlanConfiguration_" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_PlanConfiguration_" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\RecommendedApps\Source\Microsoft_Recommended Apps.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Recommended Apps" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Recommended Apps" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ReportLayouts\Source\Microsoft__Exclude_ReportLayouts.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_ReportLayouts" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_ReportLayouts" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\SalesAndInventoryForecast\Source\Microsoft_Sales and Inventory Forecast.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Sales and Inventory Forecast" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Sales and Inventory Forecast" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\SalesLinesSuggestions\Source\Microsoft_Sales Lines Suggestions.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Sales Lines Suggestions" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Sales Lines Suggestions" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\SendToEmailPrinter\Source\Microsoft_Send To Email Printer.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Send To Email Printer" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Send To Email Printer" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\SimplifiedBankStatementImport\Source\Microsoft_Simplified Bank Statement Import.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Simplified Bank Statement Import" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Simplified Bank Statement Import" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\VATGroupManagement\Source\Microsoft_VAT Group Management.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "VAT Group Management" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "VAT Group Management" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\WorldPayPaymentsStandard\Source\Microsoft_WorldPay Payments Standard.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "WorldPay Payments Standard" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "WorldPay Payments Standard" -Version $NewBcVersion

# Dependencies
Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ContosoCoffeeDemoDatasetNL\Source\Microsoft_Contoso Coffee Demo Dataset (NL).app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Contoso Coffee Demo Dataset (NL)" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Contoso Coffee Demo Dataset (NL)" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EDocument Core\Source\Microsoft_E-Document Core Demo Data.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "E-Document Core Demo Data" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "E-Document Core Demo Data" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EDocumentConnectors\Avalara\Source\Microsoft_E-Document Connector - Avalara.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "E-Document Connector - Avalara" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "E-Document Connector - Avalara" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EDocumentConnectors\Logiq\Source\Microsoft_E-Document Connector - Logiq.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "E-Document Connector - Logiq" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "E-Document Connector - Logiq" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EDocumentConnectors\SignUp\Source\Microsoft_E-Document Connector - SignUp.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "E-Document Connector - SignUp" -Version $NewBCVersion -Tenant $tenantId -Force
# Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "E-Document Connector - SignUp" -Version $NewBcVersion
Install-NavApp -ServerInstance $newBcServerInstance -Name "E-Document Connector - SignUp" -Version $newBCVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\testframework\aitesttoolkit\Microsoft_AI Test Toolkit.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "AI Test Toolkit" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "AI Test Toolkit" -Version $NewBcVersion

Publish-NavApp -serverInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\testframework\performancetoolkit\Microsoft_Performance Toolkit.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Performance Toolkit" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Performance Toolkit" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Email - Current User Connector\Source\Microsoft_Email - Current User Connector.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Email - Current User Connector" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Email - Current User Connector" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\Email - Microsoft 365 Connector\Source\Microsoft_Email - Microsoft 365 Connector.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Email - Microsoft 365 Connector" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Email - Microsoft 365 Connector" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\EmailLogging\Source\Microsoft__Exclude_Email Logging Using Graph API.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "_Exclude_Email Logging Using Graph API" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "_Exclude_Email Logging Using Graph API" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\ErrorMessagesWithRecommendations\app\Microsoft_Error Messages with Recommendations.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Error Messages with Recommendations" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Error Messages with Recommendations" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\FieldServiceIntegration\Source\Microsoft_Field Service Integration.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Field Service Integration" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Field Service Integration" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\IntrastatNL\Source\Microsoft_Intrastat NL.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Intrastat NL" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Intrastat NL" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\PowerBIReports\Source\Microsoft_PowerBI Reports.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "PowerBI Reports" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "PowerBI Reports" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\SubscriptionBilling\Source\Microsoft_Subscription Billing Demo Data.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Subscription Billing Demo Data" -Version $NewBCVersion -Tenant $tenantId -Force
# Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Subscription Billing Demo Data" -Version $NewBcVersion
Install-NavApp -ServerInstance $newBcServerInstance -Name "Subscription Billing Demo Data" -Version $NewBcVersion

Publish-NavApp -ServerInstance BC260 -Path "$appPathBC260\$dvdNameBC260\applications\AuditFileExport\Source\Microsoft_Audit File Export.app" -SkipVerification
Sync-NAVApp -ServerInstance $NewBcServerInstance -Name "Audit File Export" -Version $NewBCVersion -Tenant $tenantId -Force
Start-NAVAppDataUpgrade -ServerInstance $newBcServerInstance -Name "Audit File Export" -Version $NewBcVersion
# End publishing extensions

$extensions = Get-NavAppInfo -ServerInstance $newBcServerInstance -Version $oldBCVersion
# Loop through each extension file and sync it
foreach ($extension in $extensions) {
    # Start-NAVAppDataUpgrade -ServerInstance $NewBcServerInstance -Name $extension.Name -Version $NewBcVersion
    Uninstall-NavApp -ServerInstance $newBcServerInstance -Name $extension.Name -Version $oldBcVersion -Force -tenant $tenantId -WarningAction SilentlyContinue -ErrorAction SilentlyContinue
    Unpublish-NavApp -ServerInstance $newBcServerInstance -Name $extension.Name -Version $oldBcVersion -WarningAction SilentlyContinue -ErrorAction SilentlyContinue
}
# End start data upgrade current extensions

# Begin post upgrade tasks
Set-NAVApplication -ServerInstance $NewBcServerInstance -ApplicationVersion $NewBCVersion -Force
Sync-NAVTenant -ServerInstance $NewBcServerInstance -Mode Sync -Tenant $TenantId -Force
Start-NAVDataUpgrade -ServerInstance $NewBcServerInstance -FunctionExecutionMode Serial -Tenant $TenantId -SkipAppVersionCheck -Force
Get-NavTenant -ServerInstance $newBcServerInstance -Tenant $tenantId -Force
Dismount-NAVTenant -ServerInstance $newBcServerInstance -Tenant $tenantId -Force
Mount-NAVTenant –ServerInstance $NewBcServerInstance -Id $tenantId –DatabaseServer localhost -DatabaseName $tenantDatabase -OverwriteTenantIdInDatabase  `
-AlternateId $alternateId -DefaultCompany $defaultCompany -DefaultTimeZone $defaultTimeZone -EnvironmentType $environmentType -DisplayName $displayName -AllowAppDatabaseWrite -Force
Set-NAVServerConfiguration -ServerInstance $NewBcServerInstance -KeyName SolutionVersionExtension -KeyValue "437dbf0e-84ff-417a-965d-ed2bb9650972" -ApplyTo All
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.BusinessChart' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'BusinessChart\Microsoft.Dynamics.Nav.Client.BusinessChart.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.FlowIntegration' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'FlowIntegration\Microsoft.Dynamics.Nav.Client.FlowIntegration.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.OAuthIntegration' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'OAuthIntegration\Microsoft.Dynamics.Nav.Client.OAuthIntegration.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.PageReady' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'PageReady\Microsoft.Dynamics.Nav.Client.PageReady.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.PowerBIManagement' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'PowerBIManagement\Microsoft.Dynamics.Nav.Client.PowerBIManagement.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.RoleCenterSelector' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'RoleCenterSelector\Microsoft.Dynamics.Nav.Client.RoleCenterSelector.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.SatisfactionSurvey' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'SatisfactionSurvey\Microsoft.Dynamics.Nav.Client.SatisfactionSurvey.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.VideoPlayer' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'VideoPlayer\Microsoft.Dynamics.Nav.Client.VideoPlayer.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.WebPageViewer' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'WebPageViewer\Microsoft.Dynamics.Nav.Client.WebPageViewer.zip')
Set-NAVAddIn -ServerInstance $NewBcServerInstance -AddinName 'Microsoft.Dynamics.Nav.Client.WelcomeWizard' -PublicKeyToken 31bf3856ad364e35 -ResourceFile ($AppName = Join-Path $AddinsFolder 'WelcomeWizard\Microsoft.Dynamics.Nav.Client.WelcomeWizard.zip')
# End post upgrade tasks

